------------------------------------------------------------------------------
--                                                                          --
--                         GNAT COMPILER COMPONENTS                         --
--                                                                          --
--                              B I N D G E N                               --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.4 $                              --
--                                                                          --
--           Copyright (c) 1992,1993,1994 NYU, All Rights Reserved          --
--                                                                          --
-- GNAT is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  GNAT is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with GNAT;  see file COPYING.  If not, write --
-- to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. --
--                                                                          --
------------------------------------------------------------------------------

--  This package contains the routines to output the binder file. This is
--  a C program which contains the following:

--     initialization for main program case
--     sequence of calls to elaboration routines in appropriate order
--     call to main program for main program case

--  See the body for exact details of the file that is generated

package Bindgen is

   ------------------
   --  Subprograms --
   ------------------

   procedure Gen_Output_File;

end Bindgen;


----------------------
-- REVISION HISTORY --
----------------------

--  ----------------------------
--  revision 1.2
--  date: Mon Jul 12 23:31:13 1993;  author: dewar
--  Remove catch_except generation (per note from Cyrille)
--  ----------------------------
--  revision 1.3
--  date: Thu Jul 15 10:57:34 1993;  author: dewar
--  Remove listing of generated C file (rely on body for this information)
--  ----------------------------
--  revision 1.4
--  date: Sun Jan  9 11:00:16 1994;  author: dewar
--  New header with 1994 copyright
--  ----------------------------
--  New changes after this line.  Each line starts with: "--  "
