------------------------------------------------------------------------------
--                                                                          --
--                         GNAT COMPILER COMPONENTS                         --
--                                                                          --
--                                  P A R                                   --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.12 $                             --
--                                                                          --
--           Copyright (c) 1992,1993,1994 NYU, All Rights Reserved          --
--                                                                          --
-- GNAT is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  GNAT is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with GNAT;  see file COPYING.  If not, write --
-- to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. --
--                                                                          --
------------------------------------------------------------------------------

--  The Par procedure and its subunits contains all the parsing routines
--  for the top down recursive descent parser that constructs the parse tree

procedure Par;
--  Parse the compilation unit contained in the current source file and
--  sets the Cunit, Cunit_Entity and Unit_Name fields of the units table
--  entry for Current_Source_Unit. On return the parse tree is complete,
--  and decorated with any required implicit label declarations.


----------------------
-- REVISION HISTORY --
----------------------

--  ----------------------------
--  revision 1.10
--  date: Sun Jan  9 09:40:28 1994;  author: dewar
--  New header with 1994 copyright
--  ----------------------------
--  revision 1.11
--  date: Tue Mar 22 22:14:52 1994;  author: dewar
--  Changes for new unit table format
--  ----------------------------
--  revision 1.12
--  date: Sat Mar 26 13:29:44 1994;  author: dewar
--  New access interface for units table
--  ----------------------------
--  New changes after this line.  Each line starts with: "--  "
